<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "review_request".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ReviewRequest".
 *
 * Columns in table "review_request" available as properties of the model,
 * followed by relations of table "review_request" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property integer $patient_id
 * @property integer $google_clicked
 * @property integer $yelp_clicked
 * @property integer $ddc_clicked
 * @property integer $custom_clicked
 * @property integer $hidden
 * @property string $status
 * @property string $send_via
 * @property string $send_link
 * @property string $date_added
 * @property string $google_link
 * @property string $yelp_link
 * @property string $ddc_link
 * @property string $custom_link
 * @property string $source
 * @property string $rr_guid
 *
 * @property Account $account
 * @property Practice $practice
 * @property Patient $patient
 */
abstract class BaseReviewRequest extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'review_request';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ReviewRequest|ReviewRequests', $n);
    }

    public static function representingColumn()
    {
        return 'status';
    }

    public function rules()
    {
        return array(
            array('account_id, practice_id, patient_id, date_added', 'required'),
            array(
                'account_id, practice_id, provider_id, patient_id, google_clicked, yelp_clicked, ddc_clicked, custom_clicked, hidden',
                'numerical',
                'integerOnly' => true
            ),
            array('status, send_link', 'length', 'max' => 7),
            array('send_via', 'length', 'max' => 5),
            array('google_link, yelp_link, custom_link', 'length', 'max' => 255),
            array('rr_guid', 'length', 'max' => 40),
            array(
                'google_clicked, yelp_clicked, ddc_clicked, hidden, status, send_via, send_link, google_link,
                    yelp_link, ddc_link, custom_link, source, rr_guid',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, account_id, practice_id, provider_id, source, patient_id, google_clicked, yelp_clicked,
                    ddc_clicked, hidden, status, send_via, send_link, date_added, google_link, yelp_link, rr_guid',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'practice_id' => null,
            'provider_id' => null,
            'source' => null,
            'patient_id' => null,
            'google_clicked' => Yii::t('app', 'Google Clicked'),
            'yelp_clicked' => Yii::t('app', 'Yelp Clicked'),
            'ddc_clicked' => Yii::t('app', 'DDC Clicked'),
            'custom_clicked' => Yii::t('app', 'CUSTOM Clicked'),
            'hidden' => Yii::t('app', 'Hidden'),
            'status' => Yii::t('app', 'Status'),
            'send_via' => Yii::t('app', 'Send Via'),
            'send_link' => Yii::t('app', 'Send Link'),
            'date_added' => Yii::t('app', 'Date Added'),
            'google_link' => Yii::t('app', 'Google Link'),
            'custom_link' => Yii::t('app', 'Custom Link'),
            'yelp_link' => Yii::t('app', 'Yelp Link'),
            'ddc_link' => Yii::t('app', 'DDC Link'),
            'rr_guid' => Yii::t('app', 'The RR GUID'),
            'account' => null,
            'practice' => null,
            'patient' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('source', $this->source);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('google_clicked', $this->google_clicked);
        $criteria->compare('yelp_clicked', $this->yelp_clicked);
        $criteria->compare('ddc_clicked', $this->ddc_clicked);
        $criteria->compare('custom_clicked', $this->custom_clicked);
        $criteria->compare('hidden', $this->hidden);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('send_via', $this->send_via, true);
        $criteria->compare('send_link', $this->send_link, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('google_link', $this->google_link, true);
        $criteria->compare('custom_link', $this->custom_link, true);
        $criteria->compare('yelp_link', $this->yelp_link, true);
        $criteria->compare('ddc_link', $this->ddc_link, true);
        $criteria->compare('rr_guid', $this->rr_guid);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
